processing.app.contrib

## Class ContributionManager

- Object
- - ContributionManager

-     public class ContributionManager
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static ContributionListing` | `contribListing`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ContributionManager()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `cleanup(Base base)` Called by Base to clean up entries previously marked for deletion and remove any "requires restart" flags.
    `static void` | `downloadAndInstallOnImport(Base base, List<AvailableContribution> aList)` Blocking call to download and install a set of libraries.
    `static String` | `getFileName(File libFile)` Returns the name of a file without its path or extension.
    `static File` | `getUniqueName(File parentFolder, String fileName)` Returns a file in the parent folder that does not exist yet.
    `static void` | `refreshInstalled(Editor e)`

    - ### Methods inherited from class Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### contribListing

          public static final ContributionListing contribListing

  - ### Constructor Detail

    - #### ContributionManager

          public ContributionManager()

  - ### Method Detail

    - #### downloadAndInstallOnImport

          public static void downloadAndInstallOnImport(Base base,
                                                        List<AvailableContribution> aList)

      Blocking call to download and install a set of libraries. Used when a list of libraries have to be installed while forcing the user to not modify anything and providing feedback via the console status area, such as when the user tries to run a sketch that imports uninstaled libraries.
      Parameters:
        `aList` - The list of AvailableContributions to be downloaded and installed.

    - #### refreshInstalled

          public static void refreshInstalled(Editor e)

    - #### getUniqueName

          public static File getUniqueName(File parentFolder,
                                           String fileName)

      Returns a file in the parent folder that does not exist yet. If parent/fileName already exists, this will look for parent/fileName(2) then parent/fileName(3) and so forth.
      Returns:
        a file that does not exist yet

    - #### getFileName

          public static String getFileName(File libFile)

      Returns the name of a file without its path or extension. For example, "/path/to/helpfullib.zip" returns "helpfullib" "helpfullib-0.1.1.plb" returns "helpfullib-0.1.1"

    - #### cleanup

          public static void cleanup(Base base)
                              throws Exception

      Called by Base to clean up entries previously marked for deletion and remove any "requires restart" flags. Also updates all entries previously marked for update.
      Throws:
        `Exception`